<template>
  <div
    v-click-outside="() => open = false"
    class="ob-func-panel__control"
  >
    <div
      class="ob-func-panel__control-row"
      :class="{ 'ob-func-panel__control-row_active': open }"
      :data-qa="dataQa"
      @click="open = !open"
    >
      <i
        class="icon more"
        :class="{'painted': showHiddenLength && hiddenLength}"
      />
      <span
        v-if="showHiddenLength && hiddenLength"
        class="ob-func-panel__hidden-quantity-text"
      >
        Скрыто: {{ hiddenLength }}
      </span>
    </div>

    <transition name="fade">
      <div
        v-if="open"
        class="ob-func-panel__control-dropdown"
      >
        <div
          v-for="column in sortedColumns"
          :key="column.uuid"
          class="ob-func-panel__control-dropdown-item"
        >
          <span>{{ withCapitalLetter(column.title) }}</span>
          <span>
            <checkbox-switcher
              v-model="column._isEnabled"
              :data-qa="dataQa"
              @change="onChange(column)"
            />
          </span>
        </div>
      </div>
    </transition>
  </div>
</template>

<script>
import ClickOutside from 'vue-click-outside'
import CheckboxSwitcher from '../obSwitcherCheckbox'
import cloneDeep from 'clone-deep'

export default {
  components: {
    CheckboxSwitcher
  },
  directives: {
    ClickOutside
  },
  props: {
    columns: {
      type: Array,
      default: () => []
    },
    showHiddenLength: {
      type: Boolean,
      default: false
    },
    dataQa: {
      type: String
    }
  },
  data () {
    return {
      open: false
    }
  },
  computed: {
    hiddenLength: ({ columns }) => columns.filter(column => !column._isEnabled).length,
    sortedColumns () {
      return cloneDeep(this.columns).sort((a, b) => {
        return this.parentTable.sortDataForColumnsObj[this.parentTable.getUniqueColumnKey(a)] - this.parentTable.sortDataForColumnsObj[this.parentTable.getUniqueColumnKey(b)]
      })
    },
    parentTable () {
      const getParent = (component) => {
        if (component.$options && component.$options.name && component.$options.name === 'ObTable') {
          return component
        }

        if (!component || !component.$parent) {
          return null
        } else {
          return getParent(component.$parent)
        }
      }

      return getParent(this.$parent)
    }
  },
  methods: {
    onChange (column) {
      this.$emit('toggle-column-visibility', column)
    },
    withCapitalLetter (text) {
      return text.replace(/./, text => text.toUpperCase())
    }
  }
}
</script>

<style lang="scss" scoped>
  .ob-func-panel__hidden-quantity-text {
    font-family: "Roboto", sans-serif;
    font-size: 14px;
    line-height: 18px;
    letter-spacing: 0.2px;
    white-space: nowrap;
  }
</style>
